# Enum rustc_borrowck::diagnostics::move_errors::IllegalMoveOriginKind

source ·

    pub enum IllegalMoveOriginKind<'tcx> {
        BorrowedContent {
            target_place: Place<'tcx>,
        },
        InteriorOfTypeWithDestructor {
            container_ty: Ty<'tcx>,
        },
        InteriorOfSliceOrArray {
            ty: Ty<'tcx>,
            is_index: bool,
        },
    }

## Variants§

§

### BorrowedContent

#### Fields

§`target_place: Place<'tcx>`

The place the reference refers to: if erroneous code was trying to move from `(*x).f` this will be `*x`.

Illegal move due to attempt to move from behind a reference.

§

### InteriorOfTypeWithDestructor

#### Fields

§`container_ty: Ty<'tcx>`

Illegal move due to attempt to move from field of an ADT that implements `Drop`. Rust maintains invariant that all `Drop` ADT’s remain fully-initialized so that user-defined destructor can safely read from all of the ADT’s fields.

§

### InteriorOfSliceOrArray

#### Fields

§`ty: Ty<'tcx>`
§`is_index: bool`

Illegal move due to attempt to move out of a slice or array.

## Trait Implementations§

source§

### impl<'tcx> Debug for IllegalMoveOriginKind<'tcx>

source§

#### fn fmt(&self, f: &mut Formatter<'_>) -> Result

Formats the value using the given formatter. Read more

## Auto Trait Implementations§

§

### impl<'tcx> !RefUnwindSafe for IllegalMoveOriginKind<'tcx>

§

### impl<'tcx> Send for IllegalMoveOriginKind<'tcx>

§

### impl<'tcx> Sync for IllegalMoveOriginKind<'tcx>

§

### impl<'tcx> Unpin for IllegalMoveOriginKind<'tcx>

§

### impl<'tcx> !UnwindSafe for IllegalMoveOriginKind<'tcx>

## Blanket Implementations§

source§

### impl<T> Any for T
where T: 'static + ?Sized,

source§

#### fn type_id(&self) -> TypeId

Gets the `TypeId` of `self`. Read more
source§

### impl<T> Borrow<T> for T
where T: ?Sized,

source§

#### fn borrow(&self) -> &T

Immutably borrows from an owned value. Read more
source§

### impl<T> BorrowMut<T> for T
where T: ?Sized,

source§

#### fn borrow_mut(&mut self) -> &mut T

Mutably borrows from an owned value. Read more
source§

### impl<T> From<T> for T

source§

#### fn from(t: T) -> T

Returns the argument unchanged.

source§

### impl<T, U> Into<U> for T
where U: From<T>,

source§

#### fn into(self) -> U

Calls `U::from(self)`.

That is, this conversion is whatever the implementation of `From<T> for U` chooses to do.

source§

### impl<T, U> TryFrom<U> for T
where U: Into<T>,

§

#### type Error = Infallible

The type returned in the event of a conversion error.
source§

#### fn try_from(value: U) -> Result<T, <T as TryFrom<U>>::Error>

Performs the conversion.
source§

### impl<T, U> TryInto<U> for T
where U: TryFrom<T>,

§

#### type Error = <U as TryFrom<T>>::Error

The type returned in the event of a conversion error.
source§

#### fn try_into(self) -> Result<U, <U as TryFrom<T>>::Error>

Performs the conversion.

## Layout§

Note: Most layout information is completely unstable and may even differ between compilations. The only exception is types with certain `repr(...)` attributes. Please see the Rust Reference's “Type Layout” chapter for details on type layout guarantees.

Size: 24 bytes

Size for each variant:

- `BorrowedContent`: 23 bytes
- `InteriorOfTypeWithDestructor`: 15 bytes
- `InteriorOfSliceOrArray`: 15 bytes